require({cache:{
'epi-cms-addons-blocks/BlocksModule':function(){
﻿define("epi-cms-addons-blocks/BlocksModule", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// epi
    "epi",
    "epi/_Module",
    "epi/routes"
],

function (
// dojo
    declare,
    lang,

// epi
    epi,
    _Module,
    routes
) {

    return declare([_Module], {

        initialize: function () {
            // summary:
            //		Initialize module

            this.inherited(arguments);

            // Initialize data stores
            this._initializeStores();
        },

        _initializeStores: function () {
            // summary:
            //      Initialize data stores

            var registry = this.resolveDependency("epi.storeregistry"),
            light = registry.create("episerver.cms.addons.blocks", this._getRestPath("optimizingblock"), { id: "contentLink" });
        },

        _getRestPath: function (name) {
            return routes.getRestPath({ moduleArea: "episerver.cms.addons.blocks", storeName: name });
        }
    });
});
},
'epi-cms-addons-blocks/OptimizingBlock/VariationsEditor':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/on",
    "dojo/Deferred",
    "dojo/when",

//Dijit
    "dijit/_FocusMixin",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_CssStateMixin",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/shell/dnd/Source",
    "epi/shell/widget/ContextMenu",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/shell/command/_CommandProviderMixin",

// EPi CMS
    "epi-cms-addons-blocks/OptimizingBlock/VariantBlockEditor",
    "epi-cms-addons-blocks/OptimizingBlock/viewmodel/VariationsViewModel",
    "epi-cms/contentediting/command/BlockRemove",
    "epi-cms/contentediting/command/BlockEdit",
    "epi-cms/contentediting/editors/_TextWithActionLinksMixin",

// Resources
    "dojo/text!./templates/VariationsEditor.html"
],

function (
// Dojo
    array,
    declare,
    lang,

    domClass,
    domStyle,

    on,
    Deferred,
    when,

// Dijit
    _FocusMixin,
    _Widget,
    _TemplatedMixin,
    _CssStateMixin,
    _WidgetsInTemplateMixin,

// EPi Framework
    Source,
    ContextMenu,
    _ValueRequiredMixin,
    _CommandProviderMixin,

// EPi CMS
    VariantBlockEditor,
    VariationsViewModel,
    RemoveCommand,
    EditCommand,
    _TextWithActionLinksMixin,

// Resources
    template
) {
    return declare([
        _Widget,
        _FocusMixin,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _CssStateMixin,
        _CommandProviderMixin,
        _ValueRequiredMixin,
        _TextWithActionLinksMixin
    ], {
        // summary:
        //      A kind of ContentAreaEditor to custom optimizing block node to match with MultivariantBlock UI

        // baseClass: [public] String
        //    The widget's base CSS class.
        baseClass: "epi-content-area-editor",

        // templateString: String
        //      UI template for optimizing block's variations editor
        templateString: template,

        // dndTypes: Array string
        //      Acceptance types for dnd.
        dndTypes: ["epi.cms.content.light"],

        // _source: Source
        //      DnD source container.
        _source: null,

        // _updateModelDataThrottle: [private] Number (timeout id)
        //      Throttle timeout id for all calling.
        _updateModelDataThrottle: null,

        // supressValueChanged: [private] Boolean
        //      Avoid save, set value infinitive loop.
        supressValueChanged: false,

        // textWithLinks: [public] TextWithLinks widget
        //      An helper widget to open page/block pannel.
        textWithLinks: null,

        postMixInProperties: function () {

            this.inherited(arguments);

            if (!this.commands || this.commands.length <= 0) {
                this.commands = [
                    new EditCommand(),
                    new RemoveCommand()
                ];
            }

            this.model = this.model || new VariationsViewModel();

            this.contextMenu = this.contextMenu || new ContextMenu();
            this.contextMenu.addProvider(this);

            this.own(
                this.contextMenu,
                this.model.watch("selectedItem", lang.hitch(this, function (name, oldValue, newValue) {
                    //Update the commands with the selected block
                    this.updateCommandModel(newValue);
                })),

                on(this.model, "childrenChanged", lang.hitch(this, function (sender) {
                    this._trySave(true);
                })),

                on(this.model, "childrenOrderChanged", lang.hitch(this, function (sender) {
                    this._trySave(false);
                }))
            );
        },

        buildRendering: function () {

            this.inherited(arguments);

            domClass.add(this.domNode, "epi-variations-editor");

            this._source = new Source(this.rootNode, {
                accept: this.allowedDndTypes,
                creator: lang.hitch(this, this._createDndSourceItem),
                isSource: false,
                singular: true,
                alwaysCopy: false,
                parent: this.containerNode
            });

            this._source.defaultCheckAcceptance = this._source.checkAcceptance;
            this._source.checkAcceptance = lang.hitch(this, this._checkAcceptance);
            
            this.setupActionLinks(this.actionsContainer);
        },

        postCreate: function () {

            this.inherited(arguments);

            when(this._tryUpdateChildModelData(), lang.hitch(this, this._setupUI));
        },

        onChange: function (value) {
            // summary:
            //    Called when the value in the widget changes.
            // tags:
            //    public callback
        },

        _onBlur: function () {
            // summary:
            //      Override base to check that the context menu is showing or not.
            // tags:
            //      protected override

            if (this.contextMenu && this.contextMenu.isShowingNow) {
                return;
            }
            this.inherited(arguments);
        },

        isCreateLinkVisible: function () {
            // summary:
            //      Overidden mixin class, do not want show create link for optimizing block 
            // tags:
            //      protected

            return false;
        },

        _checkAcceptance: function (source, nodes) {
            // summary:
            //      Customize checkAcceptance func
            // source: Object
            //      The source which provides items
            // nodes: Array
            //      The list of transferred items

            return this.readOnly ? false : this._source.defaultCheckAcceptance(source, nodes);
        },

        _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);

            // hide actions when readonly
            domStyle.set(this.actionsContainer, "display", readOnly ? "none" : "");

            if (this.model) {
                this.model.set("readOnly", readOnly);
            }

        },

        focus: function () {
            // summary:
            //    Focus the tree if there is a value, else focus the create block text.
            // tags:
            //    public
            if (this.model.get("value").length > 0) {
                this._focusManager.focus(this.treeNode);
            } else {
                this.textWithLinks.focus();
            }
        },

        isValid: function () {
            // summary:
            //    Check if widget's value is valid.
            // isFocused:
            //    Indicate that the widget is being focused.
            // tags:
            //    protected

            return (!this.required || this.model.get("value").length > 0);
        },

        _trySave: function (/*Boolean*/mustUpdateModel) {
            // summary:
            //    Try save value.
            // tags:
            //    private

            if (!this._started || this.supressValueChanged) {
                return;
            }

            if (mustUpdateModel) {
                when(this._save(), lang.hitch(this, function () {
                    this._tryUpdateChildModelData().then(lang.hitch(this, this._setupUI));
                }));

                return;
            }

            // data is changed by sort, update UI only
            this._setupUI();
        },

        _save: function () {
            // summary:
            //      Save this property value

            var value = this.model.get("value");

            this._set("value", value);
            this.onChange(value);
        },

        _setValueAttr: function (value) {
            this._set("value", value || []);

            this.set("supressValueChanged", true);
            this.model.set("value", value);
            this.set("supressValueChanged", false);

            if (this._started) {
                // We still call _setupUI here to support undo/redo steps
                when(this._tryUpdateChildModelData(), lang.hitch(this, this._setupUI));
            }
        },

        _setupUI: function () {
            // summary
            //      Insert source nodes.

            this._source.selectAll();
            this._source.deleteSelectedNodes();
            this._source.insertNodes(false, this.model.getChildren());
        },

        _createBlockEditor: function (item) {
            // summary:
            //      Create new block editor, add the block model to model

            var model = this.model.createModel(item),
                itemEditor = new VariantBlockEditor({
                    contextMenu: this.contextMenu,
                    model: model
                });

            return itemEditor;
        },

        _tryUpdateChildModelData: function () {
            // summary: Update child model to get statistic info.
            //

            if (this._updateModelDataThrottle) {
                clearTimeout(this._updateModelDataThrottle);
                this._updateModelDataThrottle = null;
            }

            var dfd = new Deferred();

            this._updateModelDataThrottle = setTimeout(lang.hitch(this, function () {
                if (!this.parent) {
                    this.parent = this.getParent();
                }

                if (this.parent && this.parent.contentModel) {

                    this.model.setContentModel(this.parent.contentModel);
                }

                dfd.resolve();

            }), 200);

            return dfd;

        },

        _setParentAttr: function (parent) {
            this._set("parent", parent);

            // We should check this because of _FormEditingMixin call set("parent")
            // after editorWdiget is created.
            if (this._started) {
                when(this._tryUpdateChildModelData(), lang.hitch(this, this._setupUI));
            }
        },

        _createDndSourceItem: function (item, hint) {
            // summary:
            //      Customizes create dnd item

            if (hint == "avatar") {
                return this._source.defaultCreator(item, hint);
            }

            var itemData,
                itemEditor,
                isMyChild = this.model.isMyChild(item);
            if (!isMyChild && typeof item.getNormalizedData == "function") {
                itemData = item.getNormalizedData();
            }

            itemData = itemData ? itemData.data : item;

            // create an block editor
            itemEditor = this._createBlockEditor(itemData);
            if (!isMyChild) {
                // Item is newly created so set it as selected item
                itemEditor.model.set("selected", true);
            }

            return {
                "node": itemEditor.domNode,
                "data": itemData,
                "type": this.allowedDndTypes
            };
        }

    });
});
},
'epi-cms-addons-blocks/OptimizingBlock/VariantBlockEditor':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/when",

// Dijit
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/shell/TypeDescriptorManager",

// EPi CMS
    "epi-cms/contentediting/editors/ContentBlockEditor",
    "epi-cms/widget/Breadcrumb", // used in template
    "epi-cms-addons-blocks/OptimizingBlock/StatisticInfo",
    "epi-cms-addons-blocks/OptimizingBlock/viewmodel/StatisticInfoViewModel",

// Resources
    "dojo/text!./templates/VariantBlockEditor.html"
],

function (
// Dojo
    declare,
    lang,
    domClass,
    when,

// Dijit
    _WidgetsInTemplateMixin,

// EPi Framework
    TypeDescriptorManager,

// EPi CMS
    ContentBlockEditor,
    Breadcrumb,
    StatisticInfo,
    StatisticInfoViewModel,

// Resources
    template

) {
    return declare([ContentBlockEditor, _WidgetsInTemplateMixin], {
        // summary:
        //      A kind of BlockEditor to custom optimizing block node to match with MultivariantBlock UI

        templateString: template,

        // iconClass: string
        //      The icon class of page/block
        iconClass: "",

        postMixInProperties: function () {
            // summary:
            //      Add one more property for model mapping to change icon class for type of content
            // tags:
            //      Protected

            this.modelBindingMap = lang.mixin(this.modelBindingMap, {
                "typeIdentifier": ["typeIdentifier"]
            });

            this.inherited(arguments);
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.breadcrumbNode) {
                this.breadcrumbNode = new Breadcrumb();
            }
            this.breadcrumbNode.set("contentLink", this.contentLink);

            if (!this.statisticInfo) {
                this.statisticInfo = new StatisticInfo();
                this.statisticInfo.placeAt(this.statisticNode);
            }
            this.statisticInfo.set("model", new StatisticInfoViewModel(this.model.statisticInfo));
            if (!this.model.get("selected")) {
                this.model.set("selected", false);
            }

            this.own(
                this.model.watch("statisticInfo", lang.hitch(this, function () {
                    this.statisticInfo.set("model", new StatisticInfoViewModel(this.model.statisticInfo));
                }))
            );
        },

        _setTypeIdentifierAttr: function () {
            // summary:
            //      Change icon class for type of content
            // tags:
            //      Private
            if (TypeDescriptorManager) {
                this.iconClass = TypeDescriptorManager.getValue(this.model.typeIdentifier, "iconClass");
            }
            domClass.add(this.iconNode, this.iconClass);
        },

        _onClick: function (evt) {
            // summary:
            //      Override base method to keep selected ui when re-click on selected block.

            this.inherited(arguments);

            this.model.set("selected", true);
        }

    });
});
},
'epi-cms-addons-blocks/OptimizingBlock/StatisticInfo':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",

// Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",

// EPi Framework
    "epi/datetime",
    "epi/shell/widget/_ModelBindingMixin",

// Resources
    "dojo/text!./templates/StatisticInfo.html",
    "epi/i18n!epi/cms/nls/episerver.cms.addons.optimizingblock.statistic"
],

function (
// Dojo
    declare,
    lang,
    domConstruct,

// Dijit
    _Widget,
    _TemplatedMixin,

// EPi Framework
    epiDate,
    _ModelBindingMixin,

// Resources
    template,
    res

) {

    return declare([_Widget, _TemplatedMixin, _ModelBindingMixin], {
        // summary:
        //      A widget to display statistic information, internal used in VariantBlockEditor

        // templateString: [public] String
        //      Template for this widget (StatisticInfo.html)
        templateString: template,

        // statisticItemTemplate: [public] String
        //      A template for each item (include: Boost, Probability, ViewCount, GoalCount)
        statisticItemTemplate:
            '<li>\
                <div class="content">\
                    <div class="header">{title}</div>\
                    <div class="description">{description}</div>\
                </div>\
            </li>',

        // model: [public] Object
        //      Model for this widget (StatisticInfoViewModel)
        model: null,

        _setModelAttr: function (value) {
            // summary:
            //      Override method from _ModelBindingMixin to clear dom first.

            domConstruct.empty(this.containerNode);
            this.inherited(arguments);
        },

        modelBindingMap: {
            "boostValue": ["boostValue"],
            "probability": ["probability"],
            "viewsCount": ["viewsCount"],
            "goalCount": ["goalCount"]
        },

        _setBoostValueAttr: function (value) {
            // summary:
            //      Render UI for boost item.

            if (value === null) {
                return;
            }

            var title = res.boostvalue.title.betters.replace("{0}", value);
            if (value === 0) {
                title = res.boostvalue.title.least;
            } else if (value === 1) {
                title = res.boostvalue.title.marginally;
            }

            var html = lang.replace(this.statisticItemTemplate, {
                title: title,
                description: res.boostvalue.description
            });
            domConstruct.place(html, this.containerNode);
        },

        _setProbabilityAttr: function (value) {
            // summary:
            //      Render UI for probability item.

            if (value === null) {
                return;
            }

            var percent = value,
                title = res.probability.title
                            .replace("{0}", percent)
                            .replace("{1}", "100"),
                html = lang.replace(this.statisticItemTemplate, {
                    title: title,
                    description: res.probability.description
                });

            domConstruct.place(html, this.containerNode);
        },

        _setViewsCountAttr: function (value) {
            // summary:
            //      Render UI for view count item.

            if (value === null) {
                return;
            }

            var html;
            if (!value) {

                html = lang.replace(this.statisticItemTemplate, {
                    title: res.never.exposure,
                    description: ""
                });

            } else {

                var des = res.exposure.replace("{0}", epiDate.toUserFriendlyString(this.model.exposureDate));

                html = lang.replace(this.statisticItemTemplate, {
                    title: value,
                    description: des
                });

            }

            domConstruct.place(html, this.containerNode);
        },

        _setGoalCountAttr: function (value) {
            // summary:
            //      Render UI for goal count item.

            if (value === null) {
                return;
            }

            var html;
            if (!value) {

                html = lang.replace(this.statisticItemTemplate, {
                    title: res.never.conversion,
                    description: ""
                });

            } else {

                html = lang.replace(this.statisticItemTemplate, {
                    title: value,
                    description: res.conversion
                });

            }

            domConstruct.place(html, this.containerNode);
        }
    });
});
},
'url:epi-cms-addons-blocks/OptimizingBlock/templates/StatisticInfo.html':"﻿<div class=\"epi-optimizing-statistic\">\r\n    <ul data-dojo-attach-point=\"containerNode\"></ul>\r\n</div>\r\n",
'epi-cms-addons-blocks/OptimizingBlock/viewmodel/StatisticInfoViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful"
],function (
// Dojo
    declare,
    Stateful
) {
    return declare([Stateful], {
        // summary:
        //      Optimizing Block statistic info view model

        // boostValue: Number
        //
        boostValue: null,

        // probability: Number
        //
        probability: null,

        // viewsCount: Number
        //
        viewsCount: null,

        // goalCount: Number
        //
        goalCount: null,

        // viewDate: GMT Date Time
        //
        exposureDate: null
    });
});
},
'url:epi-cms-addons-blocks/OptimizingBlock/templates/VariantBlockEditor.html':"﻿<div class=\"epi-content-block-editor\">\r\n    <div class=\"epi-optimizing-block\">\r\n        <a href=\"#\" data-dojo-attach-point=\"itemNode\" data-dojo-attach-event=\"onclick:_onClick\">\r\n            <span data-dojo-attach-point=\"contentNode\" class=\"epi-content-block-node\" style=\"height: auto;\">\r\n                <span class=\"epi-breadCrumb\" data-dojo-attach-point=\"breadcrumbNode\" data-dojo-type=\"epi-cms/widget/Breadcrumb\"></span>\r\n                <span data-dojo-attach-point=\"iconNode\" role=\"presentation\"></span>\r\n                <span data-dojo-attach-point=\"labelNode\" class=\"epi-block-title\"></span>\r\n                <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-floatRight epi-extraIconsContainer\" role=\"presentation\">\r\n                    <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-iconContextMenu epi-extraIcon\" style=\"visibility: hidden;\" data-dojo-attach-event=\"onclick:_onContextMenu\"></span>\r\n                </span>\r\n            </span>\r\n        </a>\r\n    </div>\r\n    <div data-dojo-attach-point=\"statisticNode\"></div>\r\n</div>\r\n",
'epi-cms-addons-blocks/OptimizingBlock/viewmodel/VariationsViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",
    "dojo/has",

// EPi Framework
    "epi/dependency",

// EPi CMS
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",
    "epi-cms/contentediting/viewmodel/ContentAreaViewModel"
],

function (
// Dojo
    array,
    declare,
    lang,
    Deferred,
    all,
    when,
    has,

// EPi Framework
    dependency,

// EPi CMS
    ContentBlockViewModel,
    PersonalizedGroupViewModel,
    ContentAreaViewModel
) {
    return declare([ContentAreaViewModel], {
        // summary:
        //      Customize ContentAreaViewModel

        // dynamicDataStore: JsonRest
        //      Used to get statistic data of the block
        dynamicDataStore: null,

        // orderBy: [public] Json
        //      Order by statistic information.
        orderBy: {
            column: "boostValue",
            order: "desc"
        },

        constructor: function () {
            this.inherited(arguments);

            this.dynamicDataStore = this.dynamicDataStore || dependency.resolve("epi.storeregistry").get("episerver.cms.addons.blocks");
        },

        isMyChild: function (/*Object*/item) {
            // summary:
            //      Common method to indicate that the item is child of this model or not.
            // tags:
            //      public

            return item instanceof ContentBlockViewModel;
        },

        createModel: function (child) {
            // summary:
            //      Create ContentBlockViewModel wrap this child inside.
            // return: ContentBlockViewModel

            var model = child;
            if (!this.isMyChild(child)) {
                model = new ContentBlockViewModel(child);
                this.addChild(model);
            }

            return model;
        },

        setContentModel: function (contentModel) {
            // summary:
            //      Update child model and get their statistic data then re-ordering them by boost value desc.

            var dfd = new Deferred();

            this.set("contentModel", contentModel);

            when(this._updateStatisticInfoForModel(), lang.hitch(this, function () {
                this._sort();
                dfd.resolve();
            }));

            return dfd;
        },

        _sort: function () {
            // summary:
            //      Sort blocks order by statistic data's columns value.
            //      When we change to use dgrid then this method does not necessary.

            if (!this.orderBy || !this.orderBy.column) {
                return;
            }

            if (!this.orderBy.order) {
                this.orderBy.order = "desc";
            }

            var column = this.orderBy.column,
                isDescending = this.orderBy.order.toString().toLowerCase() === "desc",
                self = this, map = [], result = [], isOrderingChanged = false;

            function sort(a, b) {
                if (has("ie") && (a.value == b.value)) {
                    return 0;
                }
                return a.value > b.value ? 1 : -1;
            }

            function sortByAsc(a, b) { return sort(a, b); }
            function sortByDesc(a, b) { return sort(b, a); }

            map = array.map(this._data, function (item, index) {
                return {
                    value: item.statisticInfo ? parseFloat(item.statisticInfo.boostValue) : -1,
                    index: index
                };
            });

            if (isDescending) {
                map.sort(sortByDesc);
            } else {
                map.sort(sortByAsc);
            }

            result = array.map(map, function (item) {
                return self._data[item.index];
            });

            // compare old index, new index
            array.some(map, function (item, index) {
                isOrderingChanged = item.index != index;

                return isOrderingChanged;
            });

            if (isOrderingChanged) {
                // update data
                this._data = result;
                this._emitChildrenOrderingChanged();
            }
        },

        _emitChildrenOrderingChanged: function(sender) {
            // summary:
            //      Emits children changed event
            // sender: Object?
            //      The sender
            // tags:
            //      protected, internal
            
            this.emit("childrenOrderChanged", sender ? sender : this);
        },

        _updateStatisticInfoForModel: function () {
            // summary:
            //      Get statistic data then update to each child model

            function onComplete(childrens, data) {
                if (childrens && childrens.length > 0) {
                    for (var i = 0; i < childrens.length; i++) {
                        childrens[i].set("statisticInfo", data[i]);
                    }
                }
            }

            return this._updateStatisticInfo(null, onComplete);
        },

        _updateStatisticInfo: function (childModel, onComplete) {
            // summary:
            //      Get statistic data then call onComplete.

            var dfd = new Deferred();
            var childrens = this.getChildren();
            var params = {
                contentLink: this.contentModel.get("icontent_contentlink"), // optimizing block id
                variantReferences: array.map(childrens, function (child) { return child.contentLink; }), // all variants id
                variantContentLink: childModel ? childModel.contentLink : null // variant id
            };

            when(this.dynamicDataStore.query(params), function (result) {
                onComplete.call(this, childrens, result);
                dfd.resolve();
            });

            return dfd;
        }

    });
});
},
'epi-cms/contentediting/editors/_TextWithActionLinksMixin':function(){
define("epi-cms/contentediting/editors/_TextWithActionLinksMixin", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/on",
    "dojo/when",

    // EPi Framework
    "epi/shell/widget/TextWithActionLinks",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.overlay.blockarea"
],

function (
    declare,
    lang,
    Deferred,
    on,
    when,

    // EPi Framework
    TextWithActionLinks,

    // Resources
    resource
) {

    return declare(null, {
        // summary:
        //      Handles action links
        // tags:
        //      public

        // textWithLinks: [Object]
        //      The text with link area
        textWithLinks: null,

        // actionsResource: [Object]
        //      The resource of actions link
        actionsResource: resource,

        // _hasTextActionsIcon: [internal] boolean
        hasTextActionsIcon: false,

        isCreateLinkVisible: function () {
            // summary:
            //      Determines whether the "create" link in the action area is visible.
            //      Defaults to true, meaning that the link is shown.
            // returns:
            //      Promise|Boolean
            // tags:
            //      protected

            return true;
        },

        getTemplateString: function () {
            // summary:
            //      Them template string to build actions area
            // tags:
            //      protected

            var deferred = new Deferred();
            var actionResources = this.actionsResource.emptyactions;

            when(this.isCreateLinkVisible(), function (showCreateLink) {

                var templateString = showCreateLink ? actionResources.template : actionResources.templatewithoutcreate;

                deferred.resolve({
                    templateString: templateString,
                    actions: actionResources.actions
                });

            });

            return deferred.promise;
        },

        setupActionLinks: function (/*Object*/container) {
            // summary:
            //      Initial new text with action links of content area, and
            //      depend on context are create will show template without create, otherwise
            // container: [Object]
            //      The container will put text with links
            // tags:
            //      public

            when(this.getTemplateString(), lang.hitch(this, function (template) {

                if (!template) {
                    return;
                }

                this.textWithLinks = new TextWithActionLinks({
                    contentString: template.templateString,
                    namedActions: template.actions,
                    hasTextActionsIcon: this.hasTextActionsIcon
                });

                this.own(on(this.textWithLinks, "onActionClick", lang.hitch(this, this.executeAction)));
                if (container) {
                    this.textWithLinks.placeAt(container);
                }
            }));
        },

        executeAction: function (/*String*/actionName) {
            // summary:
            //      Called when action link clicked
            // tags:
            //      public

            //Override this method to implement custom actions.
        }
    });
});

},
'epi/shell/widget/TextWithActionLinks':function(){
define("epi/shell/widget/TextWithActionLinks", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/on",
    "dojo/query",

    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/focus",

    "dojox/html/entities"
], function (array,
    declare,
    event,
    lang,
    Evented,
    on,
    query,
    _WidgetBase,
    _TemplatedMixin,
    focusUtil,
    entities) {
    return declare([_WidgetBase, _TemplatedMixin, Evented], {
        // tags:
        //      public

        tagName: "span",

        templateString: "<{0}>{1}</{0}>",

        contentString: "",

        namedActions: null, // { actionName1: "<actionDisplayName1>", actionName2: "<actionDisplayName2>" }
        _actionMap: null,

        _eventHandlers: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._actionMap = [];
            this._eventHandlers = [];
            var fragments = {};
            var contentString = this.contentString;
            var namedAction;
            var id = 0;

            // replace template string with action names to create links
            if (this.namedActions) {

                for (var actionName in this.namedActions) {
                    namedAction = entities.encode(this.namedActions[actionName]);
                    fragments[actionName] = "<a class=\"epi-visibleLink\" href=\"#\" data-dojo-attach-point=\"action" + (id++) + "\">" + namedAction + "</a>";
                    this._actionMap.push(actionName);
                }

                contentString = lang.replace(contentString, fragments);
            }

            if (this.hasTextActionsIcon) {
                this.templateString = "<{0}><span class=\"epi-text-action-icon\"></span>{1}</{0}>";
            }

            this.templateString = lang.replace(this.templateString, [this.tagName, contentString]);
        },

        postCreate: function () {
            this.inherited(arguments);

            // bind events
            array.forEach(this._actionMap, function (actionName, id) {

                var link = this["action" + id];

                if (link) {

                    var handler = on(link, "click", (function (context, actionName) {
                        return function (evt) {
                            event.stop(evt);
                            context.emit("onActionClick", actionName);
                        };
                    })(this, actionName));

                    this._eventHandlers.push(handler);
                }
            }, this);
        },

        destroy: function () {

            array.forEach(this._eventHandlers, function (handler) {
                handler.remove();
            }, this);
            this._eventHandlers = null;

            this.inherited(arguments);

        },

        focus: function () {
            var links = query("a", this.domNode);

            if (links.length > 0) {
                focusUtil.focus(links[0]);
            }
        }
    });
});

},
'url:epi-cms-addons-blocks/OptimizingBlock/templates/VariationsEditor.html':"﻿<div class=\"dijitInline\" data-dojo-attach-point=\"rootNode\">\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"epi-content-area-itemcontainer\"></div>\r\n    <div data-dojo-attach-point=\"actionsContainer\" class=\"epi-content-area-actionscontainer\"></div>            \r\n</div>\r\n",
'epi-cms-addons-blocks/OptimizingBlock/OptimizingBlockArea':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/when",

// Epi Shell
    "epi/shell/dnd/Target",

// EPi CMS
    "epi-cms/widget/overlay/ContentArea",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",

// EPi Add-on
    "epi-cms-addons-blocks/OptimizingBlock/OptimizingBlockItem",
    "epi-cms-addons-blocks/OptimizingBlock/viewmodel/VariationsViewModel"
], function (

// Dojo
    array,
    declare,
    lang,
    domClass,
    when,

// EPi Shell
    Target,

// EPi CMS
    ContentArea,
    ContentBlockViewModel,

// EPi Add-on
    OptimizingBlockItem,
    VariationsViewModel

) {

    return declare([ContentArea], {

        // blockClass: [public] Class
        //      Used to inject block overlay class.
        blockClass: OptimizingBlockItem,

        // modelClass: [public] Class
        //      Used to inject model for this.
        modelClass: VariationsViewModel,

        dndSourceClass: declare([Target], { setHorizontal: function () { } }),

        // dndSourceSettings: [public] Json object
        //      Used to inject settings for dnd source.
        dndSourceSettings: { isSource: false },

        postMixInProperties: function () {
            this.inherited(arguments);

            this.model.setContentModel(this.contentModel);
        },

        postCreate: function () {
            this.inherited(arguments);

            domClass.add(this.domNode, "epi-overlay-optimizingBlockArea");

            // TODO: Trick to update statistic infor when editor wrapper cancel edit.
            // See EditingBase.js at _onWrapperCancel method
            this.watch("active", lang.hitch(this, function (name, oldValue, newValue) {
                if (newValue === false) {
                    this.model.setContentModel(this.contentModel);
                }
            }));
        },

        refresh: function () {
            this.inherited(arguments);

            this.model.setContentModel(this.contentModel);
        },

        isCreateLinkVisible: function () {
            // summary:
            //      Overidden mixin class, do not want show create link for optimizing block 
            // tags:
            //      protected

            return false;
        },

        _onDrop: function (data, source, nodes, isCopy) {
            // Overridden to get the sorting correct when rendering the update

            var model = this.model,
                target = this._source;

            // If the drag source item and drag target item are the same node then return since
            // we don't want to move if the node is dropped on itself.
            if (target.anchor === target.targetAnchor) {
                return;
            }
            
            // Normalize the data to an array.
            data = lang.isArray(data) ? data : [data];

            model.modify(function () {
                array.forEach(data, function (item) {
                    var block = new ContentBlockViewModel(item.data);
                    model.addChild(block);
                });
            });
        }
    });
});
},
'epi-cms-addons-blocks/OptimizingBlock/OptimizingBlockItem':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

// EPi Framework
    "epi/shell/TypeDescriptorManager",
    "epi-cms/widget/overlay/Block",

    "epi-cms-addons-blocks/OptimizingBlock/StatisticInfo",
    "epi-cms-addons-blocks/OptimizingBlock/viewmodel/StatisticInfoViewModel",
    "epi-cms-addons-blocks/OptimizingBlock/command/OptimizingBlockItemCommands",
    
// resources
    "dojo/text!./templates/OptimizingBlockItem.html"
],

function (
// dojo
    declare,
    lang,

    domClass,
    domGeom,
    domStyle,

// epi
    TypeDescriptorManager,
    Block,

    StatisticInfo,
    StatisticInfoViewModel,
    OptimizingBlockItemCommands,
// resources
    template
) {

    // module:
    //      epi-cms-addons-blocks/OptimizingBlock/OptimizingBlockItem
    // summary:
    //      The block widget is used together with the BlockArea widget to show the
    //      position of the different blocks for a ContentAreaProperty.
    // tags:
    //      public

    return declare([Block], {
        templateString: template,

        // iconClass: string
        //      The icon class of page/block
        iconClass: "",

        postMixInProperties: function () {

            this.inherited(arguments);
            
            // Override commands provider
            this.commandProvider = new OptimizingBlockItemCommands({ model: this.viewModel });
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(
                this.viewModel.watch("statisticInfo", lang.hitch(this, this._setupUI))
            );
        },

        updatePosition: function (position) {
            // summary:
            //      Update the position of the current content
            // tags:
            //      public, extension

            this.inherited(arguments);

            return this._updateHeight();
        },

        _setupUI: function () {
            // summary:
            //      Settings for the current content
            // tags:
            //      private

            this._buildStatisticSegment();
            this._buildHeadingSegment();
            this._updateHeight();
        },

        _buildHeadingSegment: function () {
            // summary:
            //      Custom labelNode style and resize
            // tags:
            //      private

            this.labelNode.innerHTML = "<h2>" + this.viewModel.name + "</h2>";

            if (TypeDescriptorManager) {
                this.iconClass = TypeDescriptorManager.getValue(this.viewModel.typeIdentifier, "iconClass");
            }
            domClass.add(this.iconNode, this.iconClass);
        },

        _buildStatisticSegment: function () {
            // summary:
            //      Build statistic widget or update it's model.
            // tags:
            //      private

            if (!this.statisticInfo) {
                this.statisticInfo = new StatisticInfo();
                this.statisticInfo.placeAt(this.statisticNode);
            }

            if (this.viewModel.statisticInfo) {
                this.statisticInfo.set("model", new StatisticInfoViewModel(this.viewModel.statisticInfo));
            }
        },

        _updateHeight: function () {
            // summary:
            //      Update the height of the current source content, so that, it will automatically update the height of the related overlay
            // tags:
            //      private

            var currentHeight = domGeom.getMarginBox(this.sourceItemNode).h,
                updatedHeight = domGeom.getMarginBox(this.optimizingBlockItemNode).h,
                style = { "visibility": "hidden" },
                sizeChanged = currentHeight != updatedHeight;

            if (sizeChanged) {
                style.height = updatedHeight + "px";
            }

            domStyle.set(this.sourceItemNode, style);

            return sizeChanged;
        },

        _onContextMenuClick: function () {
            // summary:
            //      Override from Block
            // tags:
            //      private

            this.commandProvider.updateCommandModel(this.viewModel);
            this.viewModel.set("selected", true);

            return false; // Return false to cause prevent default in dijit/form/_ButtonMixin
        }
    });

});

},
'epi-cms-addons-blocks/OptimizingBlock/command/OptimizingBlockItemCommands':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "dijit/Destroyable",

    "epi/shell/command/_CommandProviderMixin",

    "epi-cms/contentediting/command/BlockRemove",
    "epi-cms/contentediting/command/BlockEdit"

], function (array, declare, Stateful, Destroyable, _CommandProviderMixin, RemoveCommand, EditCommand) {

    return declare([Stateful, Destroyable, _CommandProviderMixin], {
        // summary:
        //      Class for declaring commands for OptimizingBlockItem.
        // tags:
        //      internal

        commands: null,

        constructor: function () {
            this.commands = [
                new EditCommand(),
                new RemoveCommand()
            ];

            this.commands.forEach(function (command) {
                this.own(command);
            }, this);
        },

        _modelSetter: function (model) {
            this.model = model;

            array.forEach(this.commands, function (command) {
                command.set("model", model);
            });
        }
    });
});

},
'url:epi-cms-addons-blocks/OptimizingBlock/templates/OptimizingBlockItem.html':"﻿<div class=\"dojoDndItem epi-overlay-block\">\r\n    <div data-dojo-attach-point=\"containerDomNode\">\r\n        <div class=\"epi-content-block-editor\" data-dojo-attach-point=\"optimizingBlockItemNode\">\r\n            <div class=\"epi-optimizing-block\">\r\n                <span class=\"epi-content-block-node\" style=\"height: auto;\">\r\n                    <span data-dojo-attach-point=\"iconNode\" role=\"presentation\"></span>\r\n                    <span data-dojo-attach-point=\"labelNode\" class=\"epi-block-title\"></span>\r\n                </span>\r\n            </div>            \r\n            <div data-dojo-attach-point=\"statisticNode\"></div>\r\n        </div>\r\n    </div>\r\n    <span class=\"epi-personalized\" data-dojo-attach-point=\"iconsContainer\">\r\n        <span class=\"epi-overlayControls epi-mediumButton \">\r\n            <span class=\"dijitReset dijitInline dijitIcon epi-iconWarning\" data-dojo-attach-point=\"warningIcon\"></span>\r\n            <span class=\"dijitReset dijitInline dijitIcon epi-iconUsers\" data-dojo-attach-point=\"personalizedIcon\"></span>\r\n        </span>\r\n    </span>\r\n    <button class=\"epi-chromelessButton epi-overlayControls epi-settingsButton epi-mediumButton\" data-dojo-attach-point=\"settingsButton\" data-dojo-type=\"dijit/form/DropDownButton\" data-dojo-props=\"showLabel:false, title:'${res.settingstooltip}', iconClass:'epi-iconContextMenu'\">\r\n        <span data-dojo-attach-point=\"contextMenu\" data-dojo-type=\"epi/shell/widget/ContextMenu\"></span>\r\n    </button>\r\n</div>\r\n"}});
﻿/* This is for collecting all needed modules for bundling/minifying */